package com.tzld.longarticle.recommend.server.mapper.longArticle;

import com.tzld.longarticle.recommend.server.model.entity.longArticle.ArticleCategory;
import com.tzld.longarticle.recommend.server.model.entity.longArticle.DatastatScore;
import com.tzld.longarticle.recommend.server.model.entity.longArticle.ArticlePoolPromotionSource;
import com.tzld.longarticle.recommend.server.model.entity.longArticle.DatastatSortStrategy;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

@Mapper
public interface LongArticleBaseMapper {

    void deleteByDateStrGreaterThanEqual(String dateStr);

    void deleteByDateStrBetween(String dateStrBegin, String dateStrEnd);

    void batchInsertDatastatSortStrategy(List<DatastatSortStrategy> list);

    void batchInsertArticlePoolPromotionSource(List<ArticlePoolPromotionSource> list);

    void updateRootProduceContentLevel(String rootProduceContentId, String level);

    void deleteDatastatScoreByDtIn(List<String> dateStrList);

    void batchInsertDatastatScore(List<DatastatScore> list);

    void batchInsertArticleCategory(List<ArticleCategory> list);

    List<DatastatSortStrategy> getArticlePromotion(Integer viewCount, Double viewCountRate,
                                                   Integer fans, String dateStr, List<Integer> positions);
}
