package com.tzld.longarticle.recommend.server.service.recommend.filter.strategy;

import com.ctrip.framework.apollo.spring.annotation.ApolloJsonValue;
import com.tzld.longarticle.recommend.server.model.dto.Content;
import com.tzld.longarticle.recommend.server.remote.aigc.AIGCWaitingPublishContentService;
import com.tzld.longarticle.recommend.server.service.recommend.filter.FilterParam;
import com.tzld.longarticle.recommend.server.service.recommend.filter.FilterResult;
import com.tzld.longarticle.recommend.server.service.recommend.filter.FilterStrategy;
import com.tzld.longarticle.recommend.server.util.TitleSimilarCheckUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
@Slf4j
public class BadStrategy implements FilterStrategy {

    @Autowired
    private AIGCWaitingPublishContentService aigcWaitingPublishContentService;

    @ApolloJsonValue("${badTitles:[]}")
    private static List<String> badTitles;

    @Override
    public FilterResult filter(FilterParam param) {
        long start = System.currentTimeMillis();
        FilterResult filterResult = new FilterResult();
        List<String> result = new ArrayList<>();
        List<Content> contents = param.getContents();
        List<Content> filterContents = new ArrayList<>();
        for (Content content : contents) {
            if (!TitleSimilarCheckUtil.isDuplicateContent(content.getTitle(), badTitles, TitleSimilarCheckUtil.SIMILARITY_THRESHOLD)) {
                result.add(content.getId());
            } else {
                content.setFilterReason("历史表现差的文章");
                filterContents.add(content);
            }
        }
        filterResult.setContentIds(result);
        filterResult.setFilterContent(filterContents);
        log.info("BadStrategy cost:{}", System.currentTimeMillis() - start);
        return filterResult;
    }

}